/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *
 *  Copyright (C) 2007-2008 by TAKAGI Nobuhisa
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 */
#include <fstream>
#include <algorithm>
#include <iterator>
#include "toppers/io.hpp"
#include "toppers/diagnostics.hpp"
#include <boost/format.hpp>

namespace toppers
{

  void read( std::string const& filename, std::string& buf, std::ios_base::openmode omode )
  {
    std::ifstream ifs( filename.c_str(), std::ios_base::in | omode );
    if ( !ifs.is_open() )
    {
      throw io_error( str( boost::format( _( "cannot open file `%1%\'" ) ) % filename ) );
    }
    std::string t;
    char c;
    while ( ifs.get( c ) )
    {
      t.push_back( c );
    }
    if ( ifs.bad() )
    {
      throw io_error( _( "I/O error" ) );
    }
    buf.swap( t );
  }

  void write( std::string const& filename, std::string const& buf, std::ios_base::openmode omode )
  {
    std::ofstream ofs( filename.c_str(), std::ios_base::out | omode );
    if ( !ofs.is_open() )
    {
      throw io_error( str( boost::format( _( "cannot open file `%1%\'" ) ) % filename ) );
    }
    std::copy( buf.begin(), buf.end(), std::ostream_iterator< char >( ofs ) );
    if ( ofs.bad() )
    {
      throw io_error( _( "I/O error" ) );
    }
  }

}
